enable calDAV authentication on D4Science Gateways

Jul 07, 2017 04:31 PM - Massimiliano Assante

Status: Rejected Start date: Jul 07, 2017

Priority: High Due date: Nov 30, 2017

Assignee: _InfraScience Systems Engineer % Done: 100%

Category: Application Estimated time: 0.00 hour

Target version: UnSprintable   

Infrastructure: Pre-Production, Production   

Description

The calDav integration has been activated, however there is some issue with the ha-proxy as if I try to use any of the virtual host

name iCal would fail to connect, while if i bypass it by using infra-gateway for instance (but only few of us have direct access) it

works. (see screenshot).

I also tried in dev with the virtual host name next.d4science.org and the authentication works fine.

here is a calDAV url you can try (but replace andrea.rossi with your username)

https://bluebridge.d4science.org/webdav/user/calendar/andrea.rossi/

History

#1 - Jul 07, 2017 04:32 PM - Massimiliano Assante

- Tracker changed from Support to Task

- Project changed from 24 to D4Science Infrastructure

- Category set to Application

- Assignee set to Andrea Dell'Amico

- Target version changed from Unsprintable to UnSprintable

- Infrastructure Production added

#2 - Jul 07, 2017 05:54 PM - Andrea Dell'Amico

- Assignee changed from Andrea Dell'Amico to _InfraScience Systems Engineer

#3 - Sep 27, 2017 01:38 PM - Andrea Dell'Amico

- Status changed from New to In Progress

I could have a hint, but I'd prefer to test it in dev or preprod.

#4 - Nov 27, 2017 12:24 PM - Massimiliano Assante

- Due date changed from Jul 14, 2017 to Nov 30, 2017

#5 - Nov 30, 2017 06:15 PM - Andrea Dell'Amico

- % Done changed from 0 to 60

- Infrastructure Pre-Production added

It's now working on preproduction. It seems that it could depend by some configuration that I just moved from global to local, but it was just a move so

I'm puzzled.

#6 - Dec 01, 2017 12:30 AM - Andrea Dell'Amico

It does not work, really. I can add a calendar only when a single tomcat instance is running, and this explains why it never worked in production and

why it works when you connect directly to one of the servers.

The behaviour can be reproduced easily: stop one of the backend, add a calendar (success). Remove the calendar and start the stopped backend.

Add the calendar again (fail).

From the logs and the answer returned when I try to connect with curl, the error is
HTTP/1.1 401 Unauthorized

 But the authentication header is there:

WWW-Authenticate: Digest realm="PortalRealm", nonce=<hash>"

 and I did not find any report saying that haproxy do not let pass that header (it would be huge, breaking almost every site that uses authentication)

#7 - Dec 01, 2017 12:51 AM - Andrea Dell'Amico

I just made another test, to add confusion. On both the pre and production load balancers I activated a frontend that listens on port 8443 and uses

raw tcp to contact the backend servers. That mode works for me on the preproduction servers: I'm able to add a calendar even when both the

instances are active. The same configuration does not work on the production servers. I even bypassed nginx there, so from the 8443 port the

connection goes directly to tomcat

#8 - Dec 01, 2017 12:59 AM - Andrea Dell'Amico

I also tried to start a http frontend on port 8443 and use it to backend a single tomcat instance. It does not work (we are talking about production)

#9 - Dec 01, 2017 10:44 AM - Massimiliano Assante

The difference between liferay/tomcat preproduction cluster and the production one is that in case of preproduction the ha-proxy (AFAIK) resides in

one node of the cluster (preprod1). In Production this is not true, the ha proxy is not in either of the cluster nodes. Perhaps, this could be the reason

why you have 2 different behaviours?

#10 - Dec 01, 2017 02:41 PM - Andrea Dell'Amico

I don't think so: from the haproxy point of view they are all remote targets, it never points to 'localhost' or something. And the called hostname is

different from any VM hostname.

#11 - Dec 29, 2017 06:19 PM - Andrea Dell'Amico

- Status changed from In Progress to Feedback

- % Done changed from 60 to 100

I've fixed a discrepancy in the web server and haproxy versions between the preprod and the production servers. Now they are aligned and I was

able to successfully add the production calendar. It seems that the path must end with a /

#12 - Jan 03, 2018 07:03 PM - Massimiliano Assante

- Status changed from Feedback to Closed

great!

#13 - Jan 03, 2018 07:18 PM - Andrea Dell'Amico

Andrea Dell'Amico wrote:

I've fixed a discrepancy in the web server and haproxy versions between the preprod and the production servers. Now they are aligned and I

was able to successfully add the production calendar. It seems that the path must end with a /

 A clarification: the haproxy versions were 1.6 on pre and 1.7 on the production server (and on the dev one). I only moved preproduction to 1.7, and

this is the reason why I excluded that those modification caused the OCSP problem on the production load balancers. Now all the load balancers run

haproxy 1.7 but infra dev, where 1.8 is running (pointlessly, because I discovered that the openssl library installed on Ubuntu 14.04 does not support

the alpn API, so we cannot activate http/2 without upgrading to a newer Ubuntu release).

The big difference was instead the nginx version, where on preprod1 a more modern one - from a separate repository - was installed. Now the same

repository is been used on the prod infra servers too.

#14 - Feb 22, 2018 11:50 AM - Massimiliano Assante

- Status changed from Closed to In Progress

- % Done changed from 100 to 90

Sorry Andrea, just tried to sync by using https://aginfra.d4science.org/webdav/user/calendar/andrea.rossi/ with no luck, replacing

aginfra.d4science.org with infra-gateway worked instead, what settings should I use?

#15 - Feb 22, 2018 06:48 PM - Andrea Dell'Amico

- File Screen Shot 2018-02-22 at 18.47.25.png added
It's getting personal, it seems. It's working for me using aginfra.d4science.org as server and /webdav/user/calendar/andrea.dellamico/ as path, see

screenshot

#16 - Feb 22, 2018 06:59 PM - Massimiliano Assante

- File Screen Shot 2018-02-22 at 18.58.20.png added

- File Screen Shot 2018-02-22 at 18.58.09.png added

- File Screen Shot 2018-02-22 at 18.57.36.png added

- File Screen Shot 2018-02-22 at 18.56.57.png added

what port do you use I put 443 ? tried the following, see screenshots

#17 - Feb 22, 2018 07:14 PM - Andrea Dell'Amico

- File Screen Shot 2018-02-22 at 19.13.24.png added

Yes, port 443 and hostname without the URL.

#18 - Feb 28, 2018 12:02 PM - Massimiliano Assante

- File Screen Shot 2018-02-28 at 12.00.45.png added

- File Screen Shot 2018-02-28 at 11.59.55.png added

sorry, it doesn't work with none of the 2 accounts in attachment for me ... 

#19 - Jul 03, 2018 03:14 PM - Andrea Dell'Amico

- Status changed from In Progress to Rejected

- % Done changed from 90 to 100

We didn't find a way to make it work reliably.

Files

Screen Shot 2018-02-22 at 18.47.25.png 30 KB Feb 22, 2018 Andrea Dell'Amico
